/* ccgo: go/debug.hh
 *
 * Copyright 2004 Chun-Chung Chen <cjj@u.washington.edu>
 *
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef GO_DEBUG_HH
#define GO_DEBUG_HH

#include "config.hh"
#include <iostream>

extern void fail_assert(char * file, int line, char * condition);

#ifdef assert
#undef assert
#endif

#ifdef DEBUG
#define debug(x) (void)({x})
#define assert(x) {if (!(x)) fail_assert(__FILE__, __LINE__, #x);}
#else
#define debug(x) (void) 0
#define assert(x) (void) 0
#endif

extern int debug_level;

enum DebugLevels {
	DBG_ERROR = 1,
	DBG_WARNING = 2,
	DBG_INFO = 3,
	DBG_DEBUG = 4
};

// void debug_message(int level, std::string message);
std::ostream & debug_stream(int level);
class DummyOut {};
extern DummyOut dummy_out;

template<class TT>
DummyOut & operator<< (DummyOut & o, TT)
{
	return o;
}


#ifdef DEBUG
#define msg(x) debug_stream(x)
#else
#define msg(x) dummy_out
#endif

#endif // GO_DEBUG_HH
